{************************************************}
{                                                }
{   editedtv editeur sous turbo vision           }
{   Copyright (c) 1994 by charle vidal           }
{   vidal@amertume.ufr-info-p7.ibp.fr            }
{************************************************}

program Editedtv;

uses Memory, TutConst, Drivers, Objects, Views, Menus, App, Dialogs,MsgBox,
  Editors, StdDlg,InpLong;
const cmbannerv=1000;
      cmencadre=1001;
      cmprefbanner=1002;
      cmmodifencadre=1004;
      cmmodifcentre=1005;
      cmbannerh=1006;
      cmbannerhv=1007;
      cmsaveenc=1008;
      cmsavebanner=1009;
      cmloadenc=1010;
      cmloadbanner=1011;

type PEditW=^TEditW;
     TEDitW=object(TEditWindow)
     destructor done; virtual;
     end;
type
  TMyApp = object(TApplication)
    ClipboardWindow: PEditWindow;
    constructor Init;
    procedure DoAboutBox;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure OpenWindow;
    procedure Newwindow;
    procedure encadre;
    procedure banner(h,v:boolean);
    procedure modifencadre;
    procedure prefbanner;
    procedure loadprefbanner;
    procedure loadprefencadre;
    procedure saveprefbanner;
    procedure saveprefencadre;
  end;
type charset = array[0..255,1..16] of byte;
type
  TListboxRec = record
    PS : PStringCollection;
    Focused : Integer;
    end;
type prefenc = record
    {coin}
    coin_hg:char; { haut gauche}
    coin_hd:char; { " "  droite}
    coin_bg:char; { bas gauche}
    coin_bd:char; { " " droite}
    {ligne}
    ligne_h: char; { haut et bas}
    ligne_b:char;
    ligne_d:char;  { droite et gauche}
    ligne_g:char;
 end;
 type prefban= record
    banner_bg:array[0..7] of char; { fond banner }
    banner_fg:array[0..7] of char; { devant banner }
 end;
type caractbanner = array[0..7,0..7] of char;

{*******************************
 varialble global
 *******************************}
var W:PEditW;
 fichier1: file of prefenc;
 fichier2: file of prefban;
 prefb:prefban;
 prefe:prefenc;
 DataBanner : record
    Field1 : String[10];
   end;

var
    DataRec : record
    Field1 : Word;
    Field2 : Array[1..350] of Char;
  end;


var  newcharset, oldcharset : charset;

  Cartab :record {les categories}
            Field1 : TListBoxRec;
            end;
var tb:array[1..11] of caractbanner; {Tableau Banner}
const Sseg : word = $b800; Hi = 17;
var Fseg,Fofs : word; I,Cur,Idx,Line,BitPos,large_page: byte;

{*******************************
 fonction misc
 *******************************}

procedure Getfont; assembler; asm
  mov ax,1130h; mov bh,3; int 10h; mov Fseg,es; mov Fofs,bp; end;

procedure initbanner(s:string);
begin
  for idx:=1 to 11 do begin
    Cur := ord(s[Idx]);
    for BitPos := 0 to 7 do begin
      for Line := 0 to 7 do begin
        if ((mem[Fseg:Fofs+Cur*8+Line] shl BitPos) and 128) <> 0 then
          tb[idx][Bitpos][Line]:=prefb.banner_fg[Line]
        else
          tb[idx][Bitpos][Line]:= prefb.banner_bg[Line];
      end;
    end;
  end;
end;

procedure initbanner2(s:string);
begin
  for idx:=1 to 11 do begin
    Cur := ord(s[Idx]);
    for BitPos := 0 to 7 do begin
      for Line := 0 to 7 do begin
        if ((mem[Fseg:Fofs+Cur*8+Line] shl BitPos) and 128) <> 0 then
          tb[idx][Line][BitPos]:=prefb.banner_fg[Line]
        else
          tb[idx][Line][BitPos]:=prefb.banner_bg[Line];
      end;
    end;
  end;
end;

function bannertotxt(i:byte;s:string):string;
var result:string;
    j,k:byte;
begin
 result:='';
 for k:=1 to length(s) do
 for j:=0 to 7 do
  result:=result+tb[k][i][j];
bannertotxt:=result;
end;
function bannertochar(i,k:byte):string;
var result:string;
    j:byte;
begin
 result:='';
 for j:=0 to 7 do
  result:=result+tb[k][j][i];
bannertochar:=result;
end;
procedure renverse(var s:string);
var i:byte;
    st: string;
begin
 st:='';
 for i:=length(s) downto  1 do
  begin
   st:=st+s[i];
  end;
 s:=st;
end;
procedure getoldcharset;
var
  b:byte;
  w:word;
begin
  for b := 0 to 255 do begin
    w := b * 32;
    inline($FA);
    PortW[$3C4] := $0402;
    PortW[$3C4] := $0704;
    PortW[$3CE] := $0204;
    PortW[$3CE] := $0005;
    PortW[$3CE] := $0006;
    Move(Ptr($A000, w)^, oldcharset[b,1], 16);
    PortW[$3C4] := $0302;
    PortW[$3C4] := $0304;
    PortW[$3CE] := $0004;
    PortW[$3CE] := $1005;
    PortW[$3CE] := $0E06;
    inline($FB);
  end;
end;

function string2Pstring(s1:string):PString;
var i:integer;
  s2:string;
BEGIN
 s2:='';
 for i:=1 to length(s1) do s2[i-1]:=s1[i];
 string2Pstring:=newstr(s2);
END;
function calcule_max_length:integer;
var i,j,max:integer;
begin
 i:=1;
 max:=0;
 repeat
 j:=0;
 while (datarec.field2[i]<>#13) and (datarec.field2[i]<>#0) do
    begin inc(i);inc(j); end;
 i:=i+2;
 if j>max then max:=j;
 until i>=datarec.field1;
 calcule_max_length:=max;
end;
procedure met_en_forme(var s1:string;longeur:integer);
var tempo,s2:string;
    i:integer;
BEGIN
   tempo:='';
   for i:=1 to (longeur-length(s1)) div 2 do tempo:=tempo+' ';
   with prefe do
   begin
   s2:=ligne_g+tempo+s1+tempo+ligne_d;
   if longeur+2<>length(s2) then s2:=ligne_g+tempo+s1+tempo+' '+ligne_d;
   end;
   s1:=s2;
END;
{******************************}

destructor TEDitW.Done;
begin
inherited done;
W:=nil;
end;

{*************************************
             boite de dialog
**************************************}

function choixcaractere : PDialog;
var
  Dlg : PDialog;
  R : TRect;
  Control : PView;

begin
R.Assign(47, 1, 62, 22);
New(Dlg, Init(R, ''));

R.Assign(11, 2, 12, 17);
Control := New(PScrollBar, Init(R));
Dlg^.Insert(Control);

R.Assign(3, 2, 11, 17);
Control := New(PListBox, Init(R, 1, PScrollbar(Control)));
Dlg^.Insert(Control);

  R.Assign(2, 1, 13, 2);
  Dlg^.Insert(New(PLabel, Init(R, 'caracteres', Control)));

R.Assign(3, 18, 13, 20);
Control := New(PButton, Init(R, 'O~k~', cmOK, bfDefault));
Dlg^.Insert(Control);

Dlg^.SelectNext(False);
choixcaractere := Dlg;
end;

function MakeDialog : PDialog;
var
  Dlg : PDialog;
  R : TRect;
  Control : PView;

begin
R.Assign(5, 3, 67, 10);
New(Dlg, Init(R, 'Message encadr'));

R.Assign(2, 1, 60, 4);
Control := New(PMemo, Init(R, Nil, Nil, Nil, 350));
Dlg^.Insert(Control);

R.Assign(3, 4, 13, 6);
Control := New(PButton, Init(R, 'O~k~', cmOK, bfDefault));
Dlg^.Insert(Control);

R.Assign(43, 4, 53, 6);
Control := New(PButton, Init(R, 'C~a~ncel', cmCancel, bfNormal));
Dlg^.Insert(Control);

Dlg^.SelectNext(False);
MakeDialog := Dlg;
end;

function MakeBanner : PDialog;
var
  Dlg : PDialog;
  R : TRect;
  Control : PView;

begin
R.Assign(10, 2, 40, 11);
New(Dlg, Init(R, 'Banner'));

R.Assign(7, 2, 19, 3);
Control := New(PInputLine, Init(R, 10));
Dlg^.Insert(Control);

R.Assign(3, 5, 11, 7);
Control := New(PButton, Init(R, 'O~k~', cmOK, bfDefault));
Dlg^.Insert(Control);

R.Assign(16, 5, 26, 7);
Control := New(PButton, Init(R, 'C~a~ncel', cmCancel, bfNormal));
Dlg^.Insert(Control);

Dlg^.SelectNext(False);
MakeBanner := Dlg;
end;

{*************************************}

constructor TMyApp.Init;
var
  R: TRect;
begin
  MaxHeapSize := 8192;
  EditorDialog := StdEditorDialog;
  inherited Init;
  DisableCommands([cmOrderWin, cmStockWin, cmSupplierWin]);
  Desktop^.GetExtent(R);
  ClipboardWindow := New(PEditWindow, Init(R, '', wnNoNumber));
  if ValidView(ClipboardWindow) <> nil then
  begin
    ClipboardWindow^.Hide;
    InsertWindow(ClipboardWindow);
    Clipboard := ClipboardWindow^.Editor;
    Clipboard^.CanUndo := False;
  end;
 W:=nil;
end;
function demande_char(s:string):char;
begin
MessageBox(s, nil, mfInformation + mfOkButton);
if Application^.ExecuteDialog(choixcaractere,@Cartab) = cmOk then
 demande_char:=chr(CarTab.Field1.focused+1);
end;
procedure TMyApp.prefbanner;
var i:byte;
  s:string;
  num: char;
begin
 num:='0';
 with prefb do
  begin
    for i:=0 to 7 do begin
                     s:='caractere ligne '+num+' en fond ';
                     banner_bg[i]:=demande_char(s);
                     inc(num);
                     end;
    num:='0';
    for i:=0 to 7 do begin
                     s:='caractere ligne '+num+' en 1 plan ';
                     banner_fg[i]:=demande_char(s);
                     inc(num);
                     end;
  end;
end;
procedure TMyApp.Modifencadre;
begin
  with prefe do
  begin
  coin_bg:=demande_char('caractere coin bas et a gauche');
  coin_bd:=demande_char('caractere coin bas et a droite');
  coin_hg:=demande_char('caractere coin haut et a gauche');
  coin_hd:=demande_char('caractere coin haut et a droite');
  ligne_h:=demande_char('caractere ligne haut');
  ligne_b:=demande_char('caractere ligne bas');
  ligne_d:=demande_char('caractere ligne droite');
  ligne_g:=demande_char('caractere ligne gauche');
  end;
end;
procedure TMyApp.DoAboutBox;
begin
  MessageBox(#3'editedtv'#13 +
    #3'Copyright 1994'#13#3'Charles Vidal'#13+
    #3'vidal@amertume.ufr-info-p7.ibp.fr',
    nil, mfInformation or mfOKButton);
end;

procedure TMyApp.HandleEvent(var Event: TEvent);
var
  R: TRect;
  tempo: string;
begin
  inherited HandleEvent(Event);
  if Event.What = evCommand then
  begin
    case Event.Command of
      cmClipShow:
        with ClipboardWindow^ do
        begin
          Select;
          Show;
          ClearEvent(Event);
        end;
      cmOpen:
        begin
          if w=nil then OpenWindow;
          ClearEvent(Event);
        end;
     cmNew:
        begin
          if w=nil then NewWindow;
          ClearEvent(Event);
        end;
      cmOptionsVideo:
        begin
          SetScreenMode(ScreenMode xor smFont8x8);
          ClearEvent(Event);
        end;
      cmbannerh:begin banner(FALSE,FALSE);ClearEvent(Event);end;
      cmbannerhv:begin banner(FALSE,TRUE);ClearEvent(Event);end;
      cmbannerv:begin banner(TRUE,FALSE);ClearEvent(Event);end;
      cmencadre:begin encadre;ClearEvent(Event);end;
      cmmodifencadre:begin modifencadre;end;
      cmprefbanner:begin prefbanner;end;
      cmsaveenc:begin saveprefencadre; end;
      cmsavebanner:begin saveprefbanner; end;
      cmloadenc:begin loadprefencadre; end;
      cmloadbanner:begin loadprefbanner; end;
      cmAbout:
        begin
          {tempo[0]:='a';tempo[1]:=#0;tempo[2]:=#13;
          P:=newstr(tempo);
          ClipboardWindow^.editor^.inserttext(P,3,FALSE);}
          Doaboutbox;
          ClearEvent(Event);
        end;
    end;
  end;
end;

procedure TMyApp.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
      StdFileMenuItems(nil)),
    NewSubMenu('~E~dit', hcNoContext, NewMenu(
      StdEditMenuItems(
      NewLine(
      NewItem('~S~how clipboard', '', kbNoKey, cmClipShow, hcNoContext,
      NewLine(
      NewItem('~B~anner v', '', kbNoKey, cmbannerv, hcNoContext,
      NewItem('~B~anner h', '', kbNoKey, cmbannerh, hcNoContext,
      NewItem('~B~anner h-v', '', kbNoKey, cmbannerhv, hcNoContext,
      NewItem('~E~ncadrer', '', kbNoKey, cmencadre, hcNoContext,
      nil))))))))),
    NewSubMenu('O~p~tions', hcNoContext, NewMenu(
      NewItem('~T~oggle video', '', kbNoKey, cmOptionsVideo, hcNoContext,
      NewLine(
      NewItem('~S~ave prf Banner', '', kbNoKey, cmsavebanner, hcNoContext,
      NewItem('~L~oad pref Banner', '', kbNoKey, cmloadbanner, hcNoContext,
      NewItem('S~a~ve prf encadr', '', kbNoKey, cmsaveenc, hcNoContext,
      NewItem('L~o~ad pref encadr', '', kbNoKey, cmloadenc, hcNoContext,
      NewLine(
      NewItem('~P~rference Banner', '', kbNoKey, cmprefbanner, hcNoContext,
      NewItem('P~r~eference encadrer', '', kbNoKey, cmmodifencadre, hcNoContext,
      nil)))))))))),
    NewSubMenu('~H~elp', hcNoContext, NewMenu(
      NewItem('~A~bout...', '', kbNoKey, cmAbout, hcNoContext,
      nil)),
    nil)))))));
end;

procedure TMyApp.encadre;
var i,j:integer;
    s1:string;
    P:Pstring;
    longeur:integer;
begin
if w=nil then exit;
with prefe do
 begin
fillchar(datarec,sizeof(datarec),0);
if Application^.ExecuteDialog(MakeDialog, @Datarec) = cmOk then
     begin
          longeur:=calcule_max_length;
          i:=1;
          s1:=#13#10;
          W^.editor^.inserttext(string2Pstring(s1),length(S1),FALSE);
          s1:=coin_hg;
          for j:=1 to longeur do S1:=s1+ligne_h;
          s1:=s1+coin_hd+#13#10;
          W^.editor^.inserttext(string2Pstring(s1),length(s1),FALSE);
          repeat
          s1:='';
          while (datarec.field2[i]<>#10) and (datarec.field2[i]<>#0) do
           begin if (datarec.field2[i]<>#13) then
                 s1:=s1+datarec.field2[i];inc(i);
           end;
          met_en_forme(s1,longeur); { centre s1 et place les bg }
          s1:=s1+#13#10;
          P:=string2Pstring(s1);
          W^.editor^.inserttext(P,length(s1),FALSE);
          disposestr(P);
          i:=i+1;
          until (i>=datarec.field1);
          s1:=coin_bg;
          for j:=1 to longeur do S1:=s1+ligne_b;
          s1:=s1+coin_bd+#13#10;
          W^.editor^.inserttext(string2Pstring(s1),length(s1),FALSE);
     end;
 end;
end;

procedure TMyApp.banner(h,v:boolean);
var p:pstring;
   i,j,ltempo:byte;
   tempo,s2: string;
begin
if W= nil then exit;
fillchar(databanner,sizeof(databanner),0);
if Application^.ExecuteDialog(MakeBanner, @Databanner) = cmOk then
          begin
          s2:=s2+#13#10;
          P:=string2Pstring(s2);
          W^.editor^.inserttext(P,length(s2),FALSE);
          disposestr(P);
          if h then initbanner(Databanner.field1)
             else initbanner2(Databanner.field1);
            if (h) or (v) then
              for j:=1 to length(Databanner.field1) do
              for i:=0 to 7 do
              begin
              tempo:=bannertochar(i,j);tempo:=tempo+#13#10;
              if v then renverse(tempo);
              P:=string2Pstring(tempo);
              W^.editor^.inserttext(P,length(tempo),FALSE);
              disposestr(p);
              end
            else
          for i:=0 to 7 do
              begin
               s2:=s2+#13#10;
               P:=string2Pstring(s2);
               W^.editor^.inserttext(P,length(s2),FALSE);
               disposestr(P);
               tempo:=bannertotxt(i,Databanner.field1);
               tempo:=tempo+#13#10;
               ltempo:=length(tempo);
               P:=newstr(tempo);string2Pstring(tempo);
               P^[0]:=#32;
               W^.editor^.inserttext(P,ltempo,FALSE);
               disposestr(p);
              end;
          end;
end;

procedure TMyApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, $EFFF,
      NewStatusKey('~F10~ Menu ', kbF10, cmMenu,
      NewStatusKey('~F4~ New ',kbF4,cmNew,
      NewStatusKey('~F3~ Open ', kbF3, cmOpen,
      NewStatusKey('~Alt+F3~ Close', kbAltF3, cmClose,
      NewStatusKey('~F5~ Encadrer ', kbF5, cmencadre,
      nil))))),nil)));
end;
procedure TMyApp.NewWindow;
var
  R: TRect;
  TheWindow: PEditW;
begin
  R.Assign(0, 0, 60, 20);
  TheWindow := New(PEditW, Init(R, '', wnNoNumber));
  W:=TheWindow;
  InsertWindow(TheWindow);
end;

procedure TMyApp.OpenWindow;
var
  R: TRect;
  FileDialog: PFileDialog;
  TheFile: FNameStr;
const
  FDOptions: Word = fdOKButton or fdOpenButton;
begin
  TheFile := '*.*';
  New(FileDialog, Init(TheFile, 'Open file', '~F~ile name',
    FDOptions, 1));
  if ExecuteDialog(FileDialog, @TheFile) <> cmCancel then
  begin
    R.Assign(0, 0, 75, 20);
    W:=New(PEditW, Init(R, TheFile, wnNoNumber));
    InsertWindow(W);
  end;
end;
procedure TMyApp.Loadprefencadre;
var
  R: TRect;
  FileDialog: PFileDialog;
  TheFile: FNameStr;
  b:byte;
const
  FDOptions: Word = fdOKButton or fdOpenButton;
begin
  TheFile := '*.enc';
  New(FileDialog, Init(TheFile, 'Open file', '~F~ile name',
    FDOptions, 1));
  if ExecuteDialog(FileDialog, @TheFile) <> cmCancel then
  begin
   assign(Fichier1,TheFile);
   reset(Fichier1);
   read(Fichier1,prefe);
   close(fichier1);
  end;
end;
procedure TMyApp.Loadprefbanner;
var
  R: TRect;
  FileDialog: PFileDialog;
  TheFile: FNameStr;
  b:byte;
const
  FDOptions: Word = fdOKButton or fdOpenButton;
begin
  TheFile := '*.ban';
  New(FileDialog, Init(TheFile, 'Open file', '~F~ile name',
    FDOptions, 1));
  if ExecuteDialog(FileDialog, @TheFile) <> cmCancel then
  begin
   assign(Fichier2,TheFile);
   reset(Fichier2);
   read(Fichier2,prefb);
   close(fichier2);
  end;
end;
procedure TMyApp.saveprefbanner;
var
  R: TRect;
  FileDialog: PFileDialog;
  TheFile: FNameStr;
const
  FDOptions: Word = fdOKButton or fdOpenButton;
begin
  TheFile := '*.ban';
  New(FileDialog, Init(TheFile, 'Save file', '~F~ile name',
    FDOptions, 1));
  if ExecuteDialog(FileDialog, @TheFile) <> cmCancel then
  begin
   assign(Fichier2,TheFile);
   rewrite(Fichier2);
   write(Fichier2,prefb);
   close(fichier2);
  end;
end;

procedure TMyApp.saveprefencadre;
var
  R: TRect;
  FileDialog: PFileDialog;
  TheFile: FNameStr;
const
  FDOptions: Word = fdOKButton or fdOpenButton;
begin
  TheFile := '*.enc';
  New(FileDialog, Init(TheFile, 'Save file', '~F~ile name',
    FDOptions, 1));
  if ExecuteDialog(FileDialog, @TheFile) <> cmCancel then
  begin
   assign(Fichier1,TheFile);
   rewrite(Fichier1);
   write(Fichier1,prefe);
   close(fichier1);
  end;
end;


var
  MyApp: TMyApp;
  bingo,chaine: string;
  a_cpt: byte;
begin
  GetFont;
  getoldcharset;
  newcharset:=oldcharset;
  Cartab.field1.PS:=New(PstringCollection, Init(10,5));
  bingo:='';
  for a_cpt:=1 to 254 do
     if (a_cpt<>13) and (a_cpt<>32) then
        bingo:=bingo+chr(a_cpt);
  for a_cpt:=0 to 255 do Begin
                     str(a_cpt,chaine);
                     Cartab.field1.PS^.insert(newstr(chr(a_cpt)+':'+chaine));
                     End;
  Cartab.field1.PS^.atfree(0);
for a_cpt:=0 to 7 do
 with prefb do
  begin
   banner_bg[a_cpt]:=#32;
   banner_fg[a_cpt]:=#219;
  end;
with prefe do
 begin
  coin_bg:='';
  coin_bd:='';
  coin_hg:='';
  coin_hd:='';
  ligne_h:='';
  ligne_b:='';
  ligne_d:='';
  ligne_g:='';
 end;
  MyApp.Init;
  MyApp.Run;
  MyApp.Done;
end.
